#ifndef SRC_TIME_STEPPING_RATE_BACKWARD_EULER_HH
#define SRC_TIME_STEPPING_RATE_BACKWARD_EULER_HH

template <class Vector, class Matrix, class Function, size_t dim>
class BackwardEuler : public RateUpdater<Vector, Matrix, Function, dim> {
public:
  BackwardEuler(const Matrices<Matrix> &_matrices, const std::vector<Vector> &_u_initial,
                const std::vector<Vector> &_v_initial, const std::vector<Vector> &_a_initial,
                const std::vector<Dune::BitSetVector<dim> > &_dirichletNodes,
                const std::vector<Function> &_dirichletFunctions);

  void setup(const std::vector<Vector>&, double, double, std::vector<Vector>&, std::vector<Vector>&,
             std::vector<Matrix>&) override;

  void postProcess(const std::vector<Vector>&) override;

  std::shared_ptr<RateUpdater<Vector, Matrix, Function, dim>> clone()
      const override;

private:
};
#endif
